Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4671)
@@ -5384,508 +5321,344 @@
               IF ( intermediate_timestep_count == 1 )  THEN
                  DO  kw = nzb_wall, nzt_wall
-                    surf_usm_h%tt_window_m(kw,m) = wintend(kw)
+                    surf%tt_window_m(kw,m) = wintend(kw)
                  ENDDO
               ELSEIF ( intermediate_timestep_count < intermediate_timestep_count_max )  THEN
                   DO  kw = nzb_wall, nzt_wall
-                     surf_usm_h%tt_window_m(kw,m) = -9.5625_wp * wintend(kw) +                     &
-                                                    5.3125_wp * surf_usm_h%tt_window_m(kw,m)
+                     surf%tt_window_m(kw,m) = -9.5625_wp * wintend(kw) +                     &
+                                                    5.3125_wp * surf%tt_window_m(kw,m)
                   ENDDO
               ENDIF
           ENDIF
        ENDIF
-
     ENDDO
-
-!
-!-- For vertical surfaces
-    !$OMP DO SCHEDULE (STATIC)
-    DO  l = 0, 3
-       DO  m = 1, surf_usm_v(l)%ns
-!
-!--       Obtain indices
-          i = surf_usm_v(l)%i(m)
-          j = surf_usm_v(l)%j(m)
-          k = surf_usm_v(l)%k(m)
-!
-!--       Prognostic equation for wall temperature t_wall_v
-          wtend(:) = 0.0_wp
-
-          wtend(nzb_wall) = ( 1.0_wp / surf_usm_v(l)%rho_c_wall(nzb_wall,m) )                      &
-                            * ( surf_usm_v(l)%lambda_h(nzb_wall,m)                                 &
-                                * wall_mod(nzb_wall)                                               &
-                                * ( t_wall_v(l)%t(nzb_wall+1,m)                                    &
-                                - t_wall_v(l)%t(nzb_wall,m) )                                      &
-                                * surf_usm_v(l)%ddz_wall(nzb_wall+1,m)                             &
-                                + surf_usm_v(l)%frac(m,ind_veg_wall)                               &
-                                / (surf_usm_v(l)%frac(m,ind_veg_wall)                              &
-                                + surf_usm_v(l)%frac(m,ind_pav_green) )                            &
-                                * surf_usm_v(l)%wghf_eb(m)                                         &
-                                - surf_usm_v(l)%frac(m,ind_pav_green)                              &
-                                / (surf_usm_v(l)%frac(m,ind_veg_wall)                              &
-                                + surf_usm_v(l)%frac(m,ind_pav_green) )                            &
-                                * ( surf_usm_v(l)%lambda_h_green(nzt_wall,m)                       &
-                                * wall_mod(nzt_wall)                                               &
-                                * surf_usm_v(l)%ddz_green(nzt_wall,m)                              &
-                                + surf_usm_v(l)%lambda_h(nzb_wall,m)                               &
-                                * wall_mod(nzb_wall)                                               &
-                                * surf_usm_v(l)%ddz_wall(nzb_wall,m) )                             &
-                                / ( surf_usm_v(l)%ddz_green(nzt_wall,m)                            &
-                                + surf_usm_v(l)%ddz_wall(nzb_wall,m) )                             &
-                                * ( t_wall_v(l)%t(nzb_wall,m)                                      &
-                                - t_green_v(l)%t(nzt_wall,m) )                                     &
-                              ) * surf_usm_v(l)%ddz_wall_stag(nzb_wall,m)
-
-          IF ( indoor_model )  THEN
-             DO  kw = nzb_wall+1, nzt_wall-1
-                wtend(kw) = ( 1.0_wp / surf_usm_v(l)%rho_c_wall(kw,m) )                            &
-                          * ( surf_usm_v(l)%lambda_h(kw,m)  * wall_mod(kw)                         &
-                              * ( t_wall_v(l)%t(kw+1,m) - t_wall_v(l)%t(kw,m) )                    &
-                              * surf_usm_v(l)%ddz_wall(kw+1,m)                                     &
-                              - surf_usm_v(l)%lambda_h(kw-1,m)                                     &
-                              * wall_mod(kw-1)                                                     &
-                              * ( t_wall_v(l)%t(kw,m) - t_wall_v(l)%t(kw-1,m) )                    &
-                              * surf_usm_v(l)%ddz_wall(kw,m)                                       &
-                            ) * surf_usm_v(l)%ddz_wall_stag(kw,m)
+    !$OMP END PARALLEL
+
+    IF ( debug_output_timestep )  THEN
+       WRITE( debug_string, * ) 'usm_wall_heat_model: ', horizontal, l, during_spinup
+       CALL debug_message( debug_string, 'end' )
+    ENDIF
+
+ END SUBROUTINE usm_wall_heat_model
+
+!--------------------------------------------------------------------------------------------------!
+! Description:
+! ------------
+!
+!> Green and substrate model as part of the urban surface model. The model predicts ground
+!> temperatures.
+!>
+!> Important: green-heat model crashes due to unknown reason. Green fraction is thus set to zero
+!> (in favor of wall fraction).
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE usm_green_heat_model( horizontal, l )
+
+
+    IMPLICIT NONE
+
+    LOGICAL       ::  horizontal          !< Flag indicating horizontal or vertical surfaces
+    INTEGER(iwp)  ::  l                   !< direction index
+
+    INTEGER(iwp)  ::  i, j, k, kw, m      !< running indices
+
+    LOGICAL  ::  conserve_water_content = .TRUE.  !<
+
+    REAL(wp)  ::  drho_l_lv               !< frequently used parameter
+    REAL(wp)  ::  h_vg                    !< Van Genuchten coef. h
+    REAL(wp)  ::  ke, lambda_h_green_sat  !< heat conductivity for saturated soil
+
+    REAL(wp), DIMENSION(nzb_wall:nzt_wall)   ::  gtend,tend         !< tendency
+    REAL(wp), DIMENSION(nzb_wall:nzt_wall)   ::  root_extr_green    !<
+
+    REAL(wp), DIMENSION(nzb_wall:nzt_wall+1) ::  gamma_green_temp   !< temp. gamma
+    REAL(wp), DIMENSION(nzb_wall:nzt_wall+1) ::  lambda_green_temp  !< temp. lambda
+
+    TYPE(surf_type), POINTER                 ::  surf               !< surface-date type variable
+    TYPE(surf_type_2d_usm), POINTER          ::  t_wall
+    TYPE(surf_type_2d_usm), POINTER          ::  t_green
+
+    IF ( debug_output_timestep )  THEN
+       WRITE( debug_string, * ) 'usm_green_heat_model: ', horizontal, l
+       CALL debug_message( debug_string, 'start' )
+    ENDIF
+
+    drho_l_lv = 1.0_wp / (rho_l * l_v)
+
+!
+!-- For horizontal upward surfaces.
+    IF ( horizontal .AND. l==0 )  THEN
+       surf => surf_usm_h(l)
+       t_wall       => t_wall_h(l)
+       t_green      => t_green_h(l)
+
+!--    Set tendency array for soil moisture to zero
+       IF ( surf%ns > 0 )  THEN
+          IF ( intermediate_timestep_count == 1 )  surf%tswc_h_m = 0.0_wp
+       ENDIF
+
+       !$OMP PARALLEL PRIVATE (m, i, j, k, kw, lambda_h_green_sat, ke, lambda_green_temp, gtend,    &
+       !$OMP&                  tend, h_vg, gamma_green_temp, m_total, root_extr_green)
+       !$OMP DO SCHEDULE (STATIC)
+       DO  m = 1, surf%ns
+          IF (surf%frac(m,ind_pav_green) > 0.0_wp)  THEN
+!
+!--         Obtain indices
+             i = surf%i(m)
+             j = surf%j(m)
+             k = surf%k(m)
+
+             DO  kw = nzb_wall, nzt_wall
+!
+!--             Calculate volumetric heat capacity of the soil, taking into account water content
+                surf%rho_c_total_green(kw,m) = (surf%rho_c_green(kw,m)              &
+                                                     * (1.0_wp - swc_sat_h(l)%val(kw,m))                     &
+                                                     + rho_c_water * swc_h(l)%val(kw,m))
+
+!
+!--             Calculate soil heat conductivity at the center of the soil layers
+                lambda_h_green_sat = lambda_h_green_sm ** ( 1.0_wp - swc_sat_h(l)%val(kw,m) )                &
+                                     * lambda_h_water ** swc_h(l)%val(kw,m)
+
+                ke = 1.0_wp + LOG10( MAX( 0.1_wp,swc_h(l)%val(kw,m) / swc_sat_h(l)%val(kw,m) ) )
+
+                lambda_green_temp(kw) = ke * (lambda_h_green_sat - lambda_h_green_dry)                &
+                                        + lambda_h_green_dry
+
              ENDDO
-             wtend(nzt_wall) = ( 1.0_wp / surf_usm_v(l)%rho_c_wall(nzt_wall,m) )                   &
-                               * ( -surf_usm_v(l)%lambda_h(nzt_wall-1,m) * wall_mod(nzt_wall-1)    &
-                                   * ( t_wall_v(l)%t(nzt_wall,m) - t_wall_v(l)%t(nzt_wall-1,m) )   &
-                                   * surf_usm_v(l)%ddz_wall(nzt_wall,m)                            &
-                                   + surf_usm_v(l)%iwghf_eb(m)                                     &
-                                 ) * surf_usm_v(l)%ddz_wall_stag(nzt_wall,m)
-          ELSE
+             lambda_green_temp(nzt_wall+1) = lambda_green_temp(nzt_wall)
+
+
+!
+!--          Calculate soil heat conductivity (lambda_h) at the _stag level using linear interpolation.
+!--          For pavement surface, the true pavement depth is considered
+             DO  kw = nzb_wall, nzt_wall
+                surf%lambda_h_green(kw,m) = ( lambda_green_temp(kw+1) + lambda_green_temp(kw) ) &
+                                                  * 0.5_wp
+             ENDDO
+
+             t_green_h(l)%val(nzt_wall+1,m) = t_wall_h(l)%val(nzb_wall,m)
+!
+!--          Prognostic equation for ground/roof temperature t_green_h
+             gtend(:) = 0.0_wp
+             gtend(nzb_wall) = ( 1.0_wp / surf%rho_c_total_green(nzb_wall,m) )                &
+                               * ( surf%lambda_h_green(nzb_wall,m)                            &
+                                   * ( t_green_h(l)%val(nzb_wall+1,m)                                         &
+                                   - t_green_h(l)%val(nzb_wall,m) )                                           &
+                                   * surf%ddz_green(nzb_wall+1,m)                             &
+                                   + surf%wghf_eb_green(m)                                    &
+                                 ) * surf%ddz_green_stag(nzb_wall,m)
+
              DO  kw = nzb_wall+1, nzt_wall
-                 wtend(kw) = ( 1.0_wp / surf_usm_v(l)%rho_c_wall(kw,m) )                           &
-                             * ( surf_usm_v(l)%lambda_h(kw,m) * wall_mod(kw)                       &
-                                 * ( t_wall_v(l)%t(kw+1,m) - t_wall_v(l)%t(kw,m) )                 &
-                                 * surf_usm_v(l)%ddz_wall(kw+1,m)                                  &
-                                 - surf_usm_v(l)%lambda_h(kw-1,m)                                  &
-                                 * wall_mod(kw-1)                                                  &
-                                 * ( t_wall_v(l)%t(kw,m) - t_wall_v(l)%t(kw-1,m) )                 &
-                                 * surf_usm_v(l)%ddz_wall(kw,m)                                    &
-                               ) * surf_usm_v(l)%ddz_wall_stag(kw,m)
+                gtend(kw) = ( 1.0_wp / surf%rho_c_total_green(kw,m) )                         &
+                            * ( surf%lambda_h_green(kw,m)                                     &
+                                * ( t_green_h(l)%val(kw+1,m) - t_green_h(l)%val(kw,m) )                              &
+                                * surf%ddz_green(kw+1,m)                                      &
+                                - surf%lambda_h_green(kw-1,m)                                 &
+                                * ( t_green_h(l)%val(kw,m) - t_green_h(l)%val(kw-1,m) )                              &
+                                * surf%ddz_green(kw,m)                                        &
+                              ) * surf%ddz_green_stag(kw,m)
              ENDDO
-          ENDIF
-
-          t_wall_v_p(l)%t(nzb_wall:nzt_wall,m) =  t_wall_v(l)%t(nzb_wall:nzt_wall,m) + dt_3d       &
-                                                  * ( tsc(2) * wtend(nzb_wall:nzt_wall) + tsc(3)   &
-                                                      * surf_usm_v(l)%tt_wall_m(nzb_wall:nzt_wall, &
-                                                      m) )
-
-          IF ( .NOT. during_spinup )  THEN
-             win_absorp = -log( surf_usm_v(l)%transmissivity(m) ) /                                &
-                          surf_usm_v(l)%zw_window(nzt_wall,m)
-!
-!--          Prognostic equation for window temperature t_window_v
-             wintend(:) = 0.0_wp
-             wintend(nzb_wall) = ( 1.0_wp / surf_usm_v(l)%rho_c_window(nzb_wall,m) )               &
-                                 * ( surf_usm_v(l)%lambda_h_window(nzb_wall,m)                     &
-                                     * ( t_window_v(l)%t(nzb_wall+1,m)                             &
-                                     - t_window_v(l)%t(nzb_wall,m) )                               &
-                                     * surf_usm_v(l)%ddz_window(nzb_wall+1,m)                      &
-                                     + surf_usm_v(l)%wghf_eb_window(m)                             &
-                                     + surf_usm_v(l)%rad_sw_in(m)                                  &
-                                     * ( 1.0_wp - exp( -win_absorp                                 &
-                                         * surf_usm_v(l)%zw_window(nzb_wall,m) ) )                 &
-                                   ) * surf_usm_v(l)%ddz_window_stag(nzb_wall,m)
-
-             IF ( indoor_model ) THEN
-                DO  kw = nzb_wall+1, nzt_wall -1
-                   wintend(kw) = ( 1.0_wp / surf_usm_v(l)%rho_c_window(kw,m) )                     &
-                                 * ( surf_usm_v(l)%lambda_h_window(kw,m)                           &
-                                     * ( t_window_v(l)%t(kw+1,m) - t_window_v(l)%t(kw,m) )         &
-                                     * surf_usm_v(l)%ddz_window(kw+1,m)                            &
-                                     - surf_usm_v(l)%lambda_h_window(kw-1,m)                       &
-                                     * ( t_window_v(l)%t(kw,m) - t_window_v(l)%t(kw-1,m) )         &
-                                     * surf_usm_v(l)%ddz_window(kw,m)                              &
-                                     + surf_usm_v(l)%rad_sw_in(m)                                  &
-                                     * ( exp( -win_absorp * surf_usm_v(l)%zw_window(kw-1,m) )      &
-                                         - exp(-win_absorp * surf_usm_v(l)%zw_window(kw,m) )       &
-                                       )                                                           &
-                                 ) * surf_usm_v(l)%ddz_window_stag(kw,m)
-                 ENDDO
-                 wintend(nzt_wall) = ( 1.0_wp / surf_usm_v(l)%rho_c_window(nzt_wall,m) )           &
-                                     * ( -surf_usm_v(l)%lambda_h_window(nzt_wall-1,m)              &
-                                         * ( t_window_v(l)%t(nzt_wall,m)                           &
-                                             - t_window_v(l)%t(nzt_wall-1,m) )                     &
-                                         * surf_usm_v(l)%ddz_window(nzt_wall,m)                    &
-                                         + surf_usm_v(l)%iwghf_eb_window(m)                        &
-                                         + surf_usm_v(l)%rad_sw_in(m)                              &
-                                         * ( exp( -win_absorp                                      &
-                                             * surf_usm_v(l)%zw_window(nzt_wall-1,m) )             &
-                                             - exp(-win_absorp                                     &
-                                             * surf_usm_v(l)%zw_window(nzt_wall,m) )               &
-                                           )                                                       &
-                                        ) * surf_usm_v(l)%ddz_window_stag(nzt_wall,m)
-             ELSE
-                DO  kw = nzb_wall+1, nzt_wall
-                   wintend(kw) = ( 1.0_wp / surf_usm_v(l)%rho_c_window(kw,m) )                     &
-                                 * ( surf_usm_v(l)%lambda_h_window(kw,m)                           &
-                                     * ( t_window_v(l)%t(kw+1,m) - t_window_v(l)%t(kw,m) )         &
-                                     * surf_usm_v(l)%ddz_window(kw+1,m)                            &
-                                     - surf_usm_v(l)%lambda_h_window(kw-1,m)                       &
-                                     * ( t_window_v(l)%t(kw,m) - t_window_v(l)%t(kw-1,m) )         &
-                                     * surf_usm_v(l)%ddz_window(kw,m)                              &
-                                     + surf_usm_v(l)%rad_sw_in(m)                                  &
-                                     * ( exp( -win_absorp * surf_usm_v(l)%zw_window(kw-1,m) )      &
-                                         - exp(-win_absorp                                         &
-                                         * surf_usm_v(l)%zw_window(kw,m) )                         &
-                                       )                                                           &
-                                   ) * surf_usm_v(l)%ddz_window_stag(kw,m)
-                ENDDO
-             ENDIF
-
-             t_window_v_p(l)%t(nzb_wall:nzt_wall,m) =  t_window_v(l)%t(nzb_wall:nzt_wall,m)        &
-                                                       + dt_3d * ( tsc(2)                          &
-                                                       * wintend(nzb_wall:nzt_wall)                &
-                                                       + tsc(3)                                    &
-                                                 * surf_usm_v(l)%tt_window_m(nzb_wall:nzt_wall,m) )
-          ENDIF
-
-!
-!--       Calculate t_wall tendencies for the next Runge-Kutta step
-          IF ( timestep_scheme(1:5) == 'runge' )  THEN
-              IF ( intermediate_timestep_count == 1 )  THEN
-                 DO  kw = nzb_wall, nzt_wall
-                    surf_usm_v(l)%tt_wall_m(kw,m) = wtend(kw)
-                 ENDDO
-              ELSEIF ( intermediate_timestep_count < intermediate_timestep_count_max )  THEN
-                  DO  kw = nzb_wall, nzt_wall
-                     surf_usm_v(l)%tt_wall_m(kw,m) = - 9.5625_wp * wtend(kw) +                     &
-                                                     5.3125_wp * surf_usm_v(l)%tt_wall_m(kw,m)
-                  ENDDO
-              ENDIF
-          ENDIF
-
-
-          IF ( .NOT. during_spinup )  THEN
-!
-!--          Calculate t_window tendencies for the next Runge-Kutta step
+
+             t_green_h_p(l)%val(nzb_wall:nzt_wall,m) = t_green_h(l)%val(nzb_wall:nzt_wall,m)  &
+                            + dt_3d * ( tsc(2) * gtend(nzb_wall:nzt_wall) + tsc(3)            &
+                            * surf%tt_green_m(nzb_wall:nzt_wall,m) )
+
+
+!
+!--          Calculate t_green tendencies for the next Runge-Kutta step
              IF ( timestep_scheme(1:5) == 'runge' )  THEN
                  IF ( intermediate_timestep_count == 1 )  THEN
                     DO  kw = nzb_wall, nzt_wall
-                       surf_usm_v(l)%tt_window_m(kw,m) = wintend(kw)
+                       surf%tt_green_m(kw,m) = gtend(kw)
                     ENDDO
-                 ELSEIF ( intermediate_timestep_count <  intermediate_timestep_count_max )  THEN
+                 ELSEIF ( intermediate_timestep_count < intermediate_timestep_count_max )  THEN
                      DO  kw = nzb_wall, nzt_wall
-                        surf_usm_v(l)%tt_window_m(kw,m) =  - 9.5625_wp * wintend(kw) + 5.3125_wp * &
-                                                           surf_usm_v(l)%tt_window_m(kw,m)
+                        surf%tt_green_m(kw,m) = -9.5625_wp * gtend(kw) + 5.3125_wp             &
+                                                      * surf%tt_green_m(kw,m)
                      ENDDO
                  ENDIF
              ENDIF
-          ENDIF
-
-       ENDDO
-    ENDDO
-    !$OMP END PARALLEL
-
-    IF ( debug_output_timestep )  THEN
-       WRITE( debug_string, * ) 'usm_material_heat_model | during_spinup: ', during_spinup
-       CALL debug_message( debug_string, 'end' )
-    ENDIF
-
- END SUBROUTINE usm_material_heat_model
-
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!
-!> Green and substrate model as part of the urban surface model. The model predicts ground
-!> temperatures.
-!>
-!> Important: gree-heat model crashes due to unknown reason. Green fraction is thus set to zero
-!> (in favor of wall fraction).
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE usm_green_heat_model
-
-
-    IMPLICIT NONE
-
-    INTEGER(iwp)  ::  i, j, k, l, kw, m  !< running indices
-
-    LOGICAL  ::  conserve_water_content = .TRUE.  !<
-
-    REAL(wp)  ::  drho_l_lv               !< frequently used parameter
-    REAL(wp)  ::  h_vg                    !< Van Genuchten coef. h
-    REAL(wp)  ::  ke, lambda_h_green_sat  !< heat conductivity for saturated soil
-
-    REAL(wp), DIMENSION(nzb_wall:nzt_wall)  ::  gtend,tend       !< tendency
-    REAL(wp), DIMENSION(nzb_wall:nzt_wall)  ::  root_extr_green  !<
-
-    REAL(wp), DIMENSION(nzb_wall:nzt_wall+1)  ::  gamma_green_temp   !< temp. gamma
-    REAL(wp), DIMENSION(nzb_wall:nzt_wall+1)  ::  lambda_green_temp  !< temp. lambda
-
-
-
-
-
-    IF ( debug_output_timestep )  CALL debug_message( 'usm_green_heat_model', 'start' )
-
-    drho_l_lv = 1.0_wp / (rho_l * l_v)
-
-!
-!-- For horizontal surfaces.
-!-- Set tendency array for soil moisture to zero
-    IF ( surf_usm_h%ns > 0 )  THEN
-       IF ( intermediate_timestep_count == 1 )  surf_usm_h%tswc_h_m = 0.0_wp
-    ENDIF
-
-    !$OMP PARALLEL PRIVATE (m, i, j, k, kw, lambda_h_green_sat, ke, lambda_green_temp, gtend,       &
-    !$OMP&                  tend, h_vg, gamma_green_temp, m_total, root_extr_green)
-    !$OMP DO SCHEDULE (STATIC)
-    DO  m = 1, surf_usm_h%ns
-       IF (surf_usm_h%frac(m,ind_pav_green) > 0.0_wp)  THEN
-!
-!--       Obtain indices
-          i = surf_usm_h%i(m)
-          j = surf_usm_h%j(m)
-          k = surf_usm_h%k(m)
-
-          DO  kw = nzb_wall, nzt_wall
-!
-!--          Calculate volumetric heat capacity of the soil, taking into account water content
-             surf_usm_h%rho_c_total_green(kw,m) = (surf_usm_h%rho_c_green(kw,m)                    &
-                                                  * (1.0_wp - swc_sat_h(kw,m))                     &
-                                                  + rho_c_water * swc_h(kw,m))
-
-!
-!--          Calculate soil heat conductivity at the center of the soil layers
-             lambda_h_green_sat = lambda_h_green_sm ** ( 1.0_wp - swc_sat_h(kw,m) )                &
-                                  * lambda_h_water ** swc_h(kw,m)
-
-             ke = 1.0_wp + LOG10( MAX( 0.1_wp,swc_h(kw,m) / swc_sat_h(kw,m) ) )
-
-             lambda_green_temp(kw) = ke * (lambda_h_green_sat - lambda_h_green_dry)                &
-                                     + lambda_h_green_dry
-
-          ENDDO
-          lambda_green_temp(nzt_wall+1) = lambda_green_temp(nzt_wall)
-
-
-!
-!--       Calculate soil heat conductivity (lambda_h) at the _stag level using linear interpolation.
-!--       For pavement surface, the true pavement depth is considered
-          DO  kw = nzb_wall, nzt_wall
-             surf_usm_h%lambda_h_green(kw,m) = ( lambda_green_temp(kw+1) + lambda_green_temp(kw) ) &
-                                               * 0.5_wp
-          ENDDO
-
-          t_green_h(nzt_wall+1,m) = t_wall_h(nzb_wall,m)
-!
-!--       Prognostic equation for ground/roof temperature t_green_h
-          gtend(:) = 0.0_wp
-          gtend(nzb_wall) = ( 1.0_wp / surf_usm_h%rho_c_total_green(nzb_wall,m) )                  &
-                            * ( surf_usm_h%lambda_h_green(nzb_wall,m)                              &
-                                * ( t_green_h(nzb_wall+1,m)                                        &
-                                - t_green_h(nzb_wall,m) )                                          &
-                                * surf_usm_h%ddz_green(nzb_wall+1,m)                               &
-                                + surf_usm_h%wghf_eb_green(m)                                      &
-                              ) * surf_usm_h%ddz_green_stag(nzb_wall,m)
-
-           DO  kw = nzb_wall+1, nzt_wall
-              gtend(kw) = ( 1.0_wp / surf_usm_h%rho_c_total_green(kw,m) )                          &
-                          * ( surf_usm_h%lambda_h_green(kw,m)                                      &
-                              * ( t_green_h(kw+1,m) - t_green_h(kw,m) )                            &
-                              * surf_usm_h%ddz_green(kw+1,m)                                       &
-                              - surf_usm_h%lambda_h_green(kw-1,m)                                  &
-                              * ( t_green_h(kw,m) - t_green_h(kw-1,m) )                            &
-                              * surf_usm_h%ddz_green(kw,m)                                         &
-                            ) * surf_usm_h%ddz_green_stag(kw,m)
-           ENDDO
-
-           t_green_h_p(nzb_wall:nzt_wall,m) = t_green_h(nzb_wall:nzt_wall,m) + dt_3d               &
-                                              * ( tsc(2) * gtend(nzb_wall:nzt_wall) + tsc(3)       &
-                                                  * surf_usm_h%tt_green_m(nzb_wall:nzt_wall,m) )
-
-
-!
-!--       Calculate t_green tendencies for the next Runge-Kutta step
-          IF ( timestep_scheme(1:5) == 'runge' )  THEN
-              IF ( intermediate_timestep_count == 1 )  THEN
-                 DO  kw = nzb_wall, nzt_wall
-                    surf_usm_h%tt_green_m(kw,m) = gtend(kw)
-                 ENDDO
-              ELSEIF ( intermediate_timestep_count < intermediate_timestep_count_max )  THEN
-                  DO  kw = nzb_wall, nzt_wall
-                     surf_usm_h%tt_green_m(kw,m) = -9.5625_wp * gtend(kw) + 5.3125_wp              &
-                                                   * surf_usm_h%tt_green_m(kw,m)
-                  ENDDO
-              ENDIF
-          ENDIF
-
-          DO  kw = nzb_wall, nzt_wall
-
-!
-!--          Calculate soil diffusivity at the center of the soil layers
-             lambda_green_temp(kw) = ( - b_ch * surf_usm_h%gamma_w_green_sat(kw,m) * psi_sat       &
-                                       / swc_sat_h(kw,m) )                                         &
-                                     * ( MAX( swc_h(kw,m), wilt_h(kw,m) ) / swc_sat_h(kw,m) )**    &
-                                       ( b_ch + 2.0_wp )
-
-!
-!--          Parametrization of Van Genuchten
-             IF ( soil_type /= 7 )  THEN
-!
-!--             Calculate the hydraulic conductivity after Van Genuchten (1980)
-                h_vg = ( ( (swc_res_h(kw,m) - swc_sat_h(kw,m)) / ( swc_res_h(kw,m) -               &
-                           MAX( swc_h(kw,m), wilt_h(kw,m) ) ) )**                                  &
-                           ( surf_usm_h%n_vg_green(m) / (surf_usm_h%n_vg_green(m) - 1.0_wp ) )     &
-                           - 1.0_wp                                                                &
-                       )** ( 1.0_wp / surf_usm_h%n_vg_green(m) ) / surf_usm_h%alpha_vg_green(m)
-
-
-                gamma_green_temp(kw) = surf_usm_h%gamma_w_green_sat(kw,m)                          &
-                                       * ( ( ( 1.0_wp + ( surf_usm_h%alpha_vg_green(m) * h_vg )**  &
-                                             surf_usm_h%n_vg_green(m) )**                          &
-                                             ( 1.0_wp - 1.0_wp / surf_usm_h%n_vg_green(m) )        &
-                                             - ( surf_usm_h%alpha_vg_green(m) * h_vg )**           &
-                                             ( surf_usm_h%n_vg_green(m) - 1.0_wp) )**2             &
-                                         ) / ( ( 1.0_wp + ( surf_usm_h%alpha_vg_green(m) * h_vg )**&
-                                               surf_usm_h%n_vg_green(m) )**                        &
-                                               ( ( 1.0_wp  - 1.0_wp / surf_usm_h%n_vg_green(m) )   &
-                                                 *( surf_usm_h%l_vg_green(m) + 2.0_wp) )           &
-                                             )
-
-!
-!--          Parametrization of Clapp & Hornberger
-             ELSE
-                gamma_green_temp(kw) = surf_usm_h%gamma_w_green_sat(kw,m) * ( swc_h(kw,m)          &
-                                       / swc_sat_h(kw,m) )**( 2.0_wp * b_ch + 3.0_wp )
-             ENDIF
-
-          ENDDO
-
-!
-!--       Prognostic equation for soil moisture content. Only performed, when humidity is enabled in
-!--       the atmosphere
-          IF ( humidity )  THEN
-!
-!--          Calculate soil diffusivity (lambda_w) at the _stag level using linear interpolation.
-!--          To do: replace this with ECMWF-IFS Eq. 8.81
-             DO  kw = nzb_wall, nzt_wall-1
-
-                surf_usm_h%lambda_w_green(kw,m) = ( lambda_green_temp(kw+1)                        &
-                                                    + lambda_green_temp(kw) )                      &
-                                                  * 0.5_wp
-                surf_usm_h%gamma_w_green(kw,m)  = ( gamma_green_temp(kw+1)                         &
-                                                    + gamma_green_temp(kw) )                       &
-                                                  * 0.5_wp
+
+             DO  kw = nzb_wall, nzt_wall
+
+!
+!--             Calculate soil diffusivity at the center of the soil layers
+                lambda_green_temp(kw) = ( - b_ch * surf%gamma_w_green_sat(kw,m) * psi_sat      &
+                                          / swc_sat_h(l)%val(kw,m) )                           &
+                                        * ( MAX( swc_h(l)%val(kw,m), wilt_h(l)%val(kw,m) )     &
+                                          / swc_sat_h(l)%val(kw,m) )**( b_ch + 2.0_wp )
+
+!
+!--             Parametrization of Van Genuchten
+                IF ( soil_type /= 7 )  THEN
+!
+!--                Calculate the hydraulic conductivity after Van Genuchten (1980)
+                   h_vg = ( ( (swc_res_h(l)%val(kw,m) - swc_sat_h(l)%val(kw,m))                &
+                              / ( swc_res_h(l)%val(kw,m) -                 &
+                              MAX( swc_h(l)%val(kw,m), wilt_h(l)%val(kw,m) ) ) )**                                    &
+                              ( surf%n_vg_green(m) / (surf%n_vg_green(m) - 1.0_wp ) ) &
+                              - 1.0_wp                                                                  &
+                          )** ( 1.0_wp / surf%n_vg_green(m) ) / surf%alpha_vg_green(m)
+
+
+                   gamma_green_temp(kw) = surf%gamma_w_green_sat(kw,m)                          &
+                                          * ( ( ( 1.0_wp + ( surf%alpha_vg_green(m) * h_vg )**  &
+                                                surf%n_vg_green(m) )**                          &
+                                                ( 1.0_wp - 1.0_wp / surf%n_vg_green(m) )        &
+                                                - ( surf%alpha_vg_green(m) * h_vg )**           &
+                                                ( surf%n_vg_green(m) - 1.0_wp) )**2             &
+                                            ) / ( ( 1.0_wp + ( surf%alpha_vg_green(m) * h_vg )**&
+                                                  surf%n_vg_green(m) )**                        &
+                                                  ( ( 1.0_wp  - 1.0_wp / surf%n_vg_green(m) )   &
+                                                    *( surf%l_vg_green(m) + 2.0_wp) )           &
+                                                )
+
+!
+!--             Parametrization of Clapp & Hornberger
+                ELSE
+                   gamma_green_temp(kw) = surf%gamma_w_green_sat(kw,m) * ( swc_h(l)%val(kw,m)   &
+                                          / swc_sat_h(l)%val(kw,m) )**( 2.0_wp * b_ch + 3.0_wp )
+                ENDIF
 
              ENDDO
 
 !
-!--          In case of a closed bottom (= water content is conserved), set hydraulic conductivity
-!--          to zero so that no water will be lost in the bottom layer.
-             IF ( conserve_water_content )  THEN
-                surf_usm_h%gamma_w_green(kw,m) = 0.0_wp
-             ELSE
-                surf_usm_h%gamma_w_green(kw,m) = gamma_green_temp(nzt_wall)
-             ENDIF
-
-!--          The root extraction (= root_extr * qsws_veg / (rho_l * l_v)) ensures the mass
-!--          conservation for water. The transpiration of plants equals the cumulative withdrawals
-!--          by the roots in the soil. The scheme takes into account the availability of water in
-!--          the soil layers as well as the root fraction in the respective layer. Layer with
-!--          moisture below wilting point will not contribute, which reflects the preference of
-!--          plants to take water from moister layers.
-
-!
-!--          Calculate the root extraction (ECMWF 7.69, the sum of root_extr = 1). The energy
-!--          balance solver guarantees a positive transpiration, so that there is no need for an
-!--          additional check.
-             m_total = 0.0_wp
-             DO  kw = nzb_wall, nzt_wall
-                 IF ( swc_h(kw,m) > wilt_h(kw,m) )  THEN
-                    m_total = m_total + rootfr_h(kw,m) * swc_h(kw,m)
-                 ENDIF
-             ENDDO
-
-             IF ( m_total > 0.0_wp )  THEN
+!--          Prognostic equation for soil moisture content. Only performed, when humidity is enabled in
+!--          the atmosphere
+             IF ( humidity )  THEN
+!
+!--             Calculate soil diffusivity (lambda_w) at the _stag level using linear interpolation.
+!--             To do: replace this with ECMWF-IFS Eq. 8.81
+                DO  kw = nzb_wall, nzt_wall-1
+
+                   surf%lambda_w_green(kw,m) = ( lambda_green_temp(kw+1)                     &
+                                                       + lambda_green_temp(kw) )                      &
+                                                     * 0.5_wp
+                   surf%gamma_w_green(kw,m)  = ( gamma_green_temp(kw+1)                      &
+                                                       + gamma_green_temp(kw) )                       &
+                                                     * 0.5_wp
+
+                ENDDO
+
+!
+!--             In case of a closed bottom (= water content is conserved), set hydraulic conductivity
+!--             to zero so that no water will be lost in the bottom layer.
+                IF ( conserve_water_content )  THEN
+                   surf%gamma_w_green(kw,m) = 0.0_wp
+                ELSE
+                   surf%gamma_w_green(kw,m) = gamma_green_temp(nzt_wall)
+                ENDIF
+
+!--             The root extraction (= root_extr * qsws_veg / (rho_l * l_v)) ensures the mass
+!--             conservation for water. The transpiration of plants equals the cumulative withdrawals
+!--             by the roots in the soil. The scheme takes into account the availability of water in
+!--             the soil layers as well as the root fraction in the respective layer. Layer with
+!--             moisture below wilting point will not contribute, which reflects the preference of
+!--             plants to take water from moister layers.
+
+!
+!--             Calculate the root extraction (ECMWF 7.69, the sum of root_extr = 1). The energy
+!--             balance solver guarantees a positive transpiration, so that there is no need for an
+!--             additional check.
+                m_total = 0.0_wp
                 DO  kw = nzb_wall, nzt_wall
-                   IF ( swc_h(kw,m) > wilt_h(kw,m) )  THEN
-                      root_extr_green(kw) = rootfr_h(kw,m) * swc_h(kw,m) / m_total
-                   ELSE
-                      root_extr_green(kw) = 0.0_wp
-                   ENDIF
+                    IF ( swc_h(l)%val(kw,m) > wilt_h(l)%val(kw,m) )  THEN
+                       m_total = m_total + rootfr_h(l)%val(kw,m) * swc_h(l)%val(kw,m)
+                    ENDIF
                 ENDDO
-             ENDIF
-
-!
-!--          Prognostic equation for soil water content m_soil.
-             tend(:) = 0.0_wp
-
-             tend(nzb_wall) = ( surf_usm_h%lambda_w_green(nzb_wall,m)                              &
-                              * ( swc_h(nzb_wall+1,m) - swc_h(nzb_wall,m) )                        &
-                              * surf_usm_h%ddz_green(nzb_wall+1,m)                                 &
-                              - surf_usm_h%gamma_w_green(nzb_wall,m)                               &
-                              - ( root_extr_green(nzb_wall) * surf_usm_h%qsws_veg(m)               &
-!                                 + surf_usm_h%qsws_soil_green(m)                                  &
-                                ) * drho_l_lv )                                                    &
-                              * surf_usm_h%ddz_green_stag(nzb_wall,m)
-
-             DO  kw = nzb_wall+1, nzt_wall-1
-                tend(kw) = ( surf_usm_h%lambda_w_green(kw,m)                                       &
-                             * ( swc_h(kw+1,m) - swc_h(kw,m) )                                     &
-                             * surf_usm_h%ddz_green(kw+1,m)                                        &
-                             - surf_usm_h%gamma_w_green(kw,m)                                      &
-                             - surf_usm_h%lambda_w_green(kw-1,m)                                   &
-                             * ( swc_h(kw,m) - swc_h(kw-1,m) )                                     &
-                             * surf_usm_h%ddz_green(kw,m)                                          &
-                             + surf_usm_h%gamma_w_green(kw-1,m)                                    &
-                             - (root_extr_green(kw)                                                &
-                             * surf_usm_h%qsws_veg(m)                                              &
-                             * drho_l_lv)                                                          &
-                          ) * surf_usm_h%ddz_green_stag(kw,m)
-
-             ENDDO
-             tend(nzt_wall) = ( - surf_usm_h%gamma_w_green(nzt_wall,m)                             &
-                                - surf_usm_h%lambda_w_green(nzt_wall-1,m)                          &
-                                * (swc_h(nzt_wall,m)                                               &
-                                - swc_h(nzt_wall-1,m))                                             &
-                                * surf_usm_h%ddz_green(nzt_wall,m)                                 &
-                                + surf_usm_h%gamma_w_green(nzt_wall-1,m)                           &
-                                - ( root_extr_green(nzt_wall)                                      &
-                                * surf_usm_h%qsws_veg(m)                                           &
-                                * drho_l_lv  )                                                     &
-                              ) * surf_usm_h%ddz_green_stag(nzt_wall,m)
-
-             swc_h_p(nzb_wall:nzt_wall,m) = swc_h(nzb_wall:nzt_wall,m) + dt_3d                     &
-                                            * ( tsc(2) * tend(:) + tsc(3)                          &
-                                                * surf_usm_h%tswc_h_m(:,m)                         &
-                                               )
-
-!
-!--          Account for dry soils (find a better solution here!)
-             DO  kw = nzb_wall, nzt_wall
-                IF ( swc_h_p(kw,m) < 0.0_wp )  swc_h_p(kw,m) = 0.0_wp
-             ENDDO
-
-!
-!--          Calculate m_soil tendencies for the next Runge-Kutta step
-             IF ( timestep_scheme(1:5) == 'runge' )  THEN
-                IF ( intermediate_timestep_count == 1 )  THEN
+
+                IF ( m_total > 0.0_wp )  THEN
                    DO  kw = nzb_wall, nzt_wall
-                      surf_usm_h%tswc_h_m(kw,m) = tend(kw)
-                   ENDDO
-                ELSEIF ( intermediate_timestep_count < intermediate_timestep_count_max )  THEN
-                   DO  kw = nzb_wall, nzt_wall
-                      surf_usm_h%tswc_h_m(kw,m) = -9.5625_wp * tend(kw) + 5.3125_wp                &
-                                                  * surf_usm_h%tswc_h_m(kw,m)
+                      IF ( swc_h(l)%val(kw,m) > wilt_h(l)%val(kw,m) )  THEN
+                         root_extr_green(kw) = rootfr_h(l)%val(kw,m) * swc_h(l)%val(kw,m) / m_total
+                      ELSE
+                         root_extr_green(kw) = 0.0_wp
+                      ENDIF
                    ENDDO
                 ENDIF
+
+!
+!--             Prognostic equation for soil water content m_soil.
+                tend(:) = 0.0_wp
+
+                tend(nzb_wall) = ( surf_usm_h(l)%lambda_w_green(nzb_wall,m)                           &
+                                 * ( swc_h(l)%val(nzb_wall+1,m) - swc_h(l)%val(nzb_wall,m) )          &
+                                 * surf_usm_h(l)%ddz_green(nzb_wall+1,m)                              &
+                                 - surf_usm_h(l)%gamma_w_green(nzb_wall,m)                            &
+                                 - ( root_extr_green(nzb_wall) * surf_usm_h(l)%qsws_veg(m)            &
+!                                    + surf_usm_h(l)%qsws_soil_green(m)                               &
+                                   ) * drho_l_lv )                                                    &
+                                 * surf_usm_h(l)%ddz_green_stag(nzb_wall,m)
+
+                DO  kw = nzb_wall+1, nzt_wall-1
+                   tend(kw) = ( surf_usm_h(l)%lambda_w_green(kw,m)                                    &
+                                * ( swc_h(l)%val(kw+1,m) - swc_h(l)%val(kw,m) )                       &
+                                * surf_usm_h(l)%ddz_green(kw+1,m)                                     &
+                                - surf_usm_h(l)%gamma_w_green(kw,m)                                   &
+                                - surf_usm_h(l)%lambda_w_green(kw-1,m)                                &
+                                * ( swc_h(l)%val(kw,m) - swc_h(l)%val(kw-1,m) )                       &
+                                * surf_usm_h(l)%ddz_green(kw,m)                                       &
+                                + surf_usm_h(l)%gamma_w_green(kw-1,m)                                 &
+                                - (root_extr_green(kw)                                                &
+                                * surf_usm_h(l)%qsws_veg(m)                                           &
+                                * drho_l_lv)                                                          &
+                             ) * surf_usm_h(l)%ddz_green_stag(kw,m)
+
+                ENDDO
+                tend(nzt_wall) = ( - surf_usm_h(l)%gamma_w_green(nzt_wall,m)                          &
+                                   - surf_usm_h(l)%lambda_w_green(nzt_wall-1,m)                       &
+                                   * (swc_h(l)%val(nzt_wall,m)                                        &
+                                   - swc_h(l)%val(nzt_wall-1,m))                                      &
+                                   * surf_usm_h(l)%ddz_green(nzt_wall,m)                              &
+                                   + surf_usm_h(l)%gamma_w_green(nzt_wall-1,m)                        &
+                                   - ( root_extr_green(nzt_wall)                                      &
+                                   * surf_usm_h(l)%qsws_veg(m)                                        &
+                                   * drho_l_lv  )                                                     &
+                                 ) * surf_usm_h(l)%ddz_green_stag(nzt_wall,m)
+
+                swc_h_p(l)%val(nzb_wall:nzt_wall,m) = swc_h(l)%val(nzb_wall:nzt_wall,m) + dt_3d       &
+                                               * ( tsc(2) * tend(:) + tsc(3)                          &
+                                                   * surf_usm_h(l)%tswc_h_m(:,m)                      &
+                                                  )
+
+!
+!--             Account for dry soils (find a better solution here!)
+                DO  kw = nzb_wall, nzt_wall
+                   IF ( swc_h_p(l)%val(kw,m) < 0.0_wp )  swc_h_p(l)%val(kw,m) = 0.0_wp
+                ENDDO
+
+!
+!--             Calculate m_soil tendencies for the next Runge-Kutta step
+                IF ( timestep_scheme(1:5) == 'runge' )  THEN
+                   IF ( intermediate_timestep_count == 1 )  THEN
+                      DO  kw = nzb_wall, nzt_wall
+                         surf_usm_h(l)%tswc_h_m(kw,m) = tend(kw)
+                      ENDDO
+                   ELSEIF ( intermediate_timestep_count < intermediate_timestep_count_max )  THEN
+                      DO  kw = nzb_wall, nzt_wall
+                         surf_usm_h(l)%tswc_h_m(kw,m) = -9.5625_wp * tend(kw) + 5.3125_wp             &
+                                                     * surf_usm_h(l)%tswc_h_m(kw,m)
+                      ENDDO
+                   ENDIF
+                ENDIF
              ENDIF
-          ENDIF
-
+
+          ENDIF
+       ENDDO
+       !$OMP END PARALLEL
+    ELSE
+       IF ( horizontal) THEN
+!--       For horizontal downward surfaces
+          surf         => surf_usm_h(l)
+          t_wall       => t_wall_h(l)
+          t_green      => t_green_h(l)
+       ELSE
+!--       For vertical surfaces
+          surf         => surf_usm_v(l)
+          t_wall       => t_wall_v(l)
+          t_green      => t_green_v(l)
        ENDIF
-
-    ENDDO
-    !$OMP END PARALLEL
-
-!
-!-- For vertical surfaces
-    DO  l = 0, 3
-       DO  m = 1, surf_usm_v(l)%ns
-
-          IF (surf_usm_v(l)%frac(m,ind_pav_green) > 0.0_wp)  THEN
+       !$OMP DO SCHEDULE (STATIC)
+       DO  m = 1, surf%ns
+          IF (surf%frac(m,ind_pav_green) > 0.0_wp)  THEN
 !
 !-- No substrate layer for green walls / only groundbase green walls (ivy i.e.) -> Green layers get
